/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2015 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2017 Sergej Kiselev <bilance@bilance.lv>
*/

#include "minigui.ch"
#include "tsbrowse.ch" 
#include "metrocolor.ch"

#define PROGRAM     "Xls -> Csv / Version 0.2"
#define COPYRIGHT   "(c) Copyright by Andrey Verchenko. 2017. All rights reserved. Dmitrov, Russia"

REQUEST HB_CODEPAGE_RU1251, HB_CODEPAGE_RU866
REQUEST DBFCDX, DBFFPT
MEMVAR oBrw1

PROCEDURE MAIN
   LOCAL aBackColor, aDim[3], nLbl0, nLblCol, nJ, aBColorTbr, cPicture
   LOCAL nWidth, nHeight, nTblWidth, nTblHeight, nBoxWidth, nRow, nCol, nW, nH, nL
   LOCAL hFont, cFontName, nFontSize, aFileDel, nDesktopWidth, nDesktopHeight
   LOCAL cFileDbf := ChangeFileExt( Application.ExeName, ".dbf" )
   PUBLIC cPubFindDir, oBrw1

   SET EPOCH TO ( Year(Date()) - 50 )
   SET LANGUAGE TO RUSSIAN  
   SET CODEPAGE TO RUSSIAN  
   SET Date TO GERMAN
   RDDSETDEFAULT('DBFCDX')
   SET DELETED ON
   SET AUTOPEN ON 

   _HMG_MESSAGE [4] := "    :" + CRLF + ; 
 		App.ExeName + CRLF + ; 
 		"  ." + CRLF + ; 
 		_HMG_MESSAGE [4]    
   SET MULTIPLE OFF WARNING 

   M->cPubFindDir := GetStartUpFolder() 

   IniFileRead() //    -
   MyCreateXls(M->cPubFindDir)              //   xls-
   MyCreateDbfDir(cFileDbf,M->cPubFindDir)  //    
   aFileDel := MyUseDbfIndex(cFileDbf)      //    

   cFontName := "Tahona" 
   nFontSize := ModeSizeFont() //     
   hFont := GetFontHandle( "Font_Tbr1" ) 
   IF hFont == 0
      DEFINE FONT Font_Tbr1  FONTNAME cFontName SIZE nFontSize
   ENDIF
   hFont := GetFontHandle( "Font_Tbr2" ) 
   IF hFont == 0
       DEFINE FONT Font_Tbr2  FONTNAME "Comic Sans MS" SIZE nFontSize BOLD
   ENDIF

   //nDesktopWidth  := GetDesktopWidth() * 0.6
   // -----   :   +  +   -----
   cPicture := IIF( GetDesktopWidth() == 800, cPicture := REPL("A",18) , REPL("A",20) )
   nTblWidth := GetTxtWidth( "00"     , nFontSize, cFontName )     // 
   nTblWidth += GetTxtWidth( cPicture   , nFontSize, cFontName )*2   // File
   nTblWidth += GetTxtWidth( REPL("9",9), nFontSize, cFontName )*2   // Size
   nTblWidth += GetTxtWidth( REPL("9",8), nFontSize, cFontName )*2   // Date
   nTblWidth += 48 * 2 + 24 * 4          //  Image + png order sort
   nTblWidth += GetVScrollBarWidth()+1   //   

   nDesktopWidth  := 20 * 2        //     
   nDesktopWidth  += 80            // Button
   nDesktopWidth  += nTblWidth     //  Tbrowse
   nDesktopWidth  += 20            //    
   nDesktopHeight := ( GetDesktopHeight() - GetTaskBarHeight() ) * 0.9

   DEFINE WINDOW Forma_1 AT 0,0       ;
       WIDTH nDesktopWidth HEIGHT nDesktopHeight ;
       MAIN                           ;
       TITLE PROGRAM                  ; 
       ICON "1MAIN_ICO"               ;
       BACKCOLOR COLOR_LIGHT_GREEN    ;
       NOMAXIMIZE NOSIZE              ;
       FONT cFontName SIZE nFontSize  ;
       ON INIT    { || OnInitForma1(), ChangeTable(oBrw1) }  ;
       ON RELEASE { || OnCloseForma1(cFileDbf,aFileDel) } 

       nWidth  := This.ClientWidth   
       nHeight := This.ClientHeight  

       aBackColor := COLOR_GREEN_METRO

       nLbl0 := 100
       @ 0, 0 LABEL Label_0 WIDTH nWidth HEIGHT nLbl0 VALUE "" ;
         FONT cFontName SIZE nFontSize BOLD  CENTERALIGN ;
         FONTCOLOR aBackColor BACKCOLOR aBackColor  VCENTERALIGN

       @ 2, 20 IMAGE Image_1 PICTURE 'LOGO' WIDTH 96 HEIGHT 96 STRETCH ;
         TRANSPARENT BACKGROUNDCOLOR aBackColor ;
         ACTION MsgAbout() OnMouseHover RC_CURSOR( "MINIGUI_FINGER" )

       aDim[1] := MiniGUIVersion()  
       aDim[2] := "  XLS  CSV  OLE Excel"  
       aDim[3] := ""  
 
       nJ := nLbl0/3 
       nLblCol := Forma_1.Image_1.Width + Forma_1.Image_1.Col + 5
       @ 0, nLblCol LABEL Label_1 WIDTH nWidth-nLblCol HEIGHT nJ VALUE aDim[1] ;
          FONT "Times New Roman" SIZE 12 BOLD  CENTERALIGN ;
          FONTCOLOR WHITE BACKCOLOR aBackColor  VCENTERALIGN

       nH := IIF( GetDesktopWidth() == 800 , 18, 22 )
       @ nJ*1-5, nLblCol LABEL Label_2 WIDTH nWidth-nLblCol HEIGHT nJ+10 VALUE aDim[2] ;
          FONT "Comic Sans MS" SIZE nH BOLD CENTERALIGN ;
          FONTCOLOR YELLOW BACKCOLOR aBackColor  VCENTERALIGN
       @ nJ*2+5, nLblCol LABEL Label_3 WIDTH nWidth-nLblCol HEIGHT nJ-5 VALUE aDim[3] ;
          FONT "Tahona" SIZE 10 BOLD  CENTERALIGN ;
          FONTCOLOR BLACK BACKCOLOR aBackColor  VCENTERALIGN

       nBoxWidth := nTblWidth - 40 - 5
       @ nLbl0+10,20  TEXTBOX TextBox_1 VALUE M->cPubFindDir WIDTH nBoxWidth-7 HEIGHT 26 BACKCOLOR WHITE READONLY
       @ nLbl0+10,20+nBoxWidth-2 BUTTON Button_1 PICTURE 'OPEN_BMP' WIDTH 40 HEIGHT 26;
          ACTION  {|| GetFileXls(cFileDbf), IniFileWrite() }

       nRow := nLbl0 + 10*2 + Forma_1.TextBox_1.Height
       nCol := 20
       nTblHeight := nDesktopHeight - ( nRow + 20*2 + 22 + 7 )
       //    
       //@ nRow, nCol LABEL Label_Tbrowse VALUE "" ;
       //  WIDTH nTblWidth HEIGHT nTblHeight BACKCOLOR WHITE  

       aBColorTbr := {240, 240, 240 } //WHITE //COLOR_LIGHT_GREEN
       /////////////////////// Building TsBrowse  ////////////////////////////
       MyTableXLS2CVS(nRow,nCol,nTblWidth,nTblHeight,aBColorTbr)
       /////////////////////// Building TsBrowse  ////////////////////////////
       //    
       // DRAW LINE IN WINDOW Forma_1 AT nRow-5, nCol TO nRow-5, nTblWidth+nCol ;
       //     PENCOLOR RED PENWIDTH 4

       IF GetDesktopWidth() == 800
          nW := 68 ; nH := 68  ;  nL := nWidth-nH-2
       ELSE
          nW := 80 ; nH := 80  ;  nL := nWidth-nH-20+4
       ENDIF

       @ nRow,nL BUTTONEX Button_Conv TOOLTIP "" ;
          WIDTH nW HEIGHT nH BACKCOLOR COLOR_BRIGHT_ORANGE FONTCOLOR WHITE BOLD  ;
          ICON "Conv64" NOXPSTYLE HANDCURSOR ACTION ( oBrw1:PostMsg( WM_KEYDOWN, VK_RETURN, 0 ), ;
                                                      oBrw1:SetFocus() ) ;
          NOTABSTOP

       @ nRow+nH+15,nL BUTTONEX Button_View TOOLTIP " " ;
          WIDTH nW HEIGHT nH BACKCOLOR COLOR_OF2016_GREEN FONTCOLOR WHITE BOLD  ;
          ICON "View64" NOXPSTYLE HANDCURSOR ACTION ( oBrw1:PostMsg( WM_KEYDOWN, VK_RETURN, 0 ), ; 
                                                      oBrw1:SetFocus() ) ;
          NOTABSTOP
     
       @ nHeight-20*2-80*2-22,nL BUTTONEX Button_Help TOOLTIP " " ;
          WIDTH nW HEIGHT nH BACKCOLOR COLOR_YELLOW_METRO FONTCOLOR WHITE BOLD  ;
          ICON "Help64" NOXPSTYLE HANDCURSOR ACTION  ( MsgAbout(), oBrw1:SetFocus() ) ;
          NOTABSTOP
     
       @ nHeight-20-80-22,nL BUTTONEX Button_Exit TOOLTIP ' ' + CRLF +'' ;
          WIDTH nW HEIGHT nH BACKCOLOR COLOR_RED_METRO FONTCOLOR WHITE BOLD ;
          ICON "Exit64" NOXPSTYLE HANDCURSOR ACTION  {|| ThisWindow.Release } ;
          NOTABSTOP
          
       @ nHeight-280,nL BUTTONEX Button_Save /*CAPTION ' ' + CRLF +''*/ ;
          WIDTH 91 HEIGHT 31 BACKCOLOR COLOR_AZURE3 ;
          NOXPSTYLE HANDCURSOR ACTION  {|| ThisWindow.Release } INVISIBLE

       @ nHeight-22,0  LABEL Label_Copyright VALUE COPYRIGHT ; 
         WIDTH nWidth HEIGHT 22 ;
         FONTCOLOR WHITE BACKCOLOR aBackColor ;
         SIZE 10 BOLD CENTERALIGN VCENTERALIGN 

   END WINDOW

   CENTER WINDOW Forma_1
   ACTIVATE WINDOW Forma_1

RETURN

////////////////////////////////////////////////////////////
FUNCTION OnInitForma1()
  LOCAL cInfo, cPath, aRet := {1,""}

  aRet := MyExcelVersion()
  cInfo := ":  " + aRet[2] + "  (" + HB_NtoS(aRet[1]) + ")   " 

  cPath := MyExcelPath()
  cPath := IIF( cPath == NIL, "???????", cPath)
  cInfo += "  Excel:  " + cPath
   
  Forma_1.Label_3.Value := cInfo
  //      
  //Forma_1.Button_Save.SaveAs( "Button_Save.bmp" )

  TblFocus()  //   

RETURN NIL

////////////////////////////////////////////////////////////
FUNCTION OnCloseForma1(cFileDbf,aFileDel)  
   LOCAL nI, cFile
   
   CLOSE ALL
   cFile := cFileDbf
   DELETEFILE(cFileDbf)
   FOR nI := 1 TO LEN(aFileDel)
      cFile := aFileDel[nI]
      DELETEFILE(cFile)
   NEXT
   
RETURN NIL

//////////////////////////////////////////////////////////////////////////////
Function GetFileXls(cFileDbf)
   LOCAL a, cFile

   a := Getfile ( { {'XLS files','*.xls'} } , 'Open file(s)' , M->cPubFindDir , .t. , .t. )
   IF LEN(a) > 0
      cFile := a[1] 
      M->cPubFindDir := SUBSTR(cFile,1,RAT("\",cFile)-1)
      Forma_1.Textbox_1.Value := M->cPubFindDir
      CLOSE ALL
      MyCreateDbfDir(cFileDbf,M->cPubFindDir)
      MyUseDbfIndex(cFileDbf)

      oBrw1:Reset()
      oBrw1:Refresh(.T.)
      oBrw1:nCell := 2     //    
   ENDIF

   RETURN NIL
//////////////////////////////////////////////////////////////////////////////
Function IniFileWrite()
   Local cText, cFileIni := ChangeFileExt( Application.ExeName, ".ini" )
   Local cSection := "Setting"
                  
   IF ! File( cFileIni )
      cText := "[Information]" + CRLF
      cText += "Program = " + PROGRAM + CRLF
      cText += "Author  = " + COPYRIGHT + CRLF
      cText += "Free Open Source Software = " + Version() + CRLF
      cText += "Free Compiler = " + hb_compiler() + CRLF
      cText += "Free Library  = " + MiniGUIVersion() + CRLF
      cText += "" + CRLF
      cText += "[RUSSIAN]" + CRLF + CRLF
      HB_MemoWrit( cFileIni, cText )
   ENDIF

   WriteIni( cSection, "PATH_DIR"   , M->cPubFindDir , cFileIni )

Return Nil

//////////////////////////////////////////////////////////////////////////////
Function IniFileRead()
   Local cFileIni := ChangeFileExt( Application.ExeName, ".ini" )
   Local cSection := "Setting"
                  
   IF ! File( cFileIni )
       IniFileWrite()
   ENDIF

   M->cPubFindDir := GetIni( cSection , "PATH_DIR" , M->cPubFindDir, cFileIni )        

Return Nil

*--------------------------------------------------------*
STATIC Function GetIni( cSection, cEntry, cDefault, cFile )
RETURN GetPrivateProfileString(cSection, cEntry, cDefault, cFile )
*--------------------------------------------------------*
STATIC Function WriteIni( cSection, cEntry, cValue, cFile )
RETURN( WritePrivateProfileString( cSection, cEntry, cValue, cFile ) )
