/*
 * MINIGUI - Harbour Win32 GUI library
 *
 * Copyright 2015 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"

///////////////////////////////////////////////////////////////////////////////////
// --------- TSCOLUMN.PRG -------------------------------
// DATA hFont          // 1-cells font
// DATA hFontHead      // 2-header font
// DATA hFontFoot      // 3-footer font
// DATA hFontSpcHd     // 4-special header font
// DATA hFontEdit      // 5-edition font
FUNCTION LoadTbrwFonts(oBrw)   //    TBROWSE 
   LOCAL aFontTmp, hFont, aFonts := {}

    //hFont := oBrw:hFont     // 1-cells font
    hFont := oBrw:aColumns[ 1 ]:hFont     // 1-cells font
    If hFont != Nil
       aFontTmp := GetFontParam(hFont)
       AADD( aFonts, aFontTmp )
    ENDIF

    hFont := oBrw:aColumns[ 1 ]:hFontHead  // 2-header font
    If hFont != Nil
       aFontTmp := GetFontParam(hFont)
       AADD( aFonts, aFontTmp )
    ENDIF

    hFont := oBrw:aColumns[ 1 ]:hFontFoot  // 3-footer font
    If hFont != Nil
       aFontTmp := GetFontParam(hFont)
       AADD( aFonts, aFontTmp )
    ENDIF

   /* hFont := oBrw:aSuperHead[ 1, 7 ]  // 4-special header font
    If hFont != Nil
       aFontTmp := GetFontParam(hFont)
       AADD( aFonts, aFontTmp )
    ENDIF
    */
    hFont := oBrw:aColumns[ 1 ]:hFontEdit   // 5-edition font
    If hFont != Nil
       aFontTmp := GetFontParam(hFont)
       AADD( aFonts, aFontTmp )
    ENDIF

RETURN aFonts

//////////////////////////////////////////////////////////////////////
FUNCTION TableInfoFont(cMenuFont,aTableFont) 
    LOCAL cMsg

    cMsg := Replicate( "-._.", 22 ) + CRLF + CRLF
    cMsg += cMenuFont + CRLF + CRLF
    cMsg += "1-cells font          - " + HB_ValToExp(aTableFont[1]) + CRLF
    cMsg += "2-header font         - " + HB_ValToExp(aTableFont[2]) + CRLF
    cMsg += "3-footer font         - " + HB_ValToExp(aTableFont[3]) + CRLF
    cMsg += "4-special header font - " + HB_ValToExp(aTableFont[4]) + CRLF + CRLF
    //cMsg += "5-edition font       " + HB_ValToExp(aTableFont[5]) + CRLF + CRLF
    cMsg += Replicate( "-._.", 22 ) + CRLF + CRLF
    MsgInfo(cMsg," ")

    RETURN Nil

///////////////////////////////////////////////////////////////////////////////
FUNCTION GetTxtWidth( cText, nFontSize, cFontName )  //  width 
LOCAL hFont, nWidth

 IF valtype(cText) == 'N'
    cText := repl('A', cText)
 ENDIF

 DEFAULT cText     := repl('A', 2),          ;
         cFontName := _HMG_DefaultFontName,  ;   //  MiniGUI.Init()
         nFontSize := _HMG_DefaultFontSize       //  MiniGUI.Init()

 hFont  := InitFont(cFontName, nFontSize)
 nWidth := GetTextWidth(0, cText, hFont)
 
 //MsgDebug(cText, nFontSize, cFontName, hFont, nWidth)
 DeleteObject (hFont)                    

RETURN nWidth

///////////////////////////////////////////////////////////////////////////////
Function ModeScreen()
LOCAL cMsg, nMode := 0

IF GetDesktopHeight() < 600 
    cMsg := DTOC(DATE())+" "+TIME()+" -  !" + CRLF + CRLF
    cMsg += "      800600 !" + CRLF + CRLF 
    cMsg += "   : " + LTRIM(STR(GetDesktopWidth()))+"x"+LTRIM(STR(GetDesktopHeight())) + CRLF + CRLF  
    cMsg += "   !" + CRLF 
    MsgStop( cMsg )
    QUIT
ENDIF 

IF GetDesktopWidth() == 800
   nMode := 1
ELSEIF GetDesktopWidth() == 1024
   nMode := 2
ELSEIF GetDesktopWidth() == 1152
   nMode := 3
ELSEIF GetDesktopWidth() == 1280
   nMode := 4
ELSE
   nMode := 5
ENDIF

RETURN nMode

//////////////////////////////////////////////////////////////////////
Function ModeSizeFont()
LOCAL nSize := 10

IF GetDesktopHeight() == 600
   nSize := IIF(LargeFonts(),7,8)
ELSEIF GetDesktopHeight() == 768
   nSize := IIF(LargeFonts(),9,10)
ELSEIF GetDesktopHeight() == 800
   nSize := IIF(LargeFonts(),11,12)
ELSEIF (GetDesktopHeight() >= 1050 .AND. GetDesktopHeight() <= 1080)
   nSize := IIF(LargeFonts(),12,14)
ELSEIF GetDesktopHeight() == 1152
   nSize := IIF(LargeFonts(),14,16)
ELSEIF GetDesktopHeight() >= 1200
   nSize := IIF(LargeFonts(),16,18)
ELSE
   nSize := 12
ENDIF
//? GetDesktopHeight(), GetDesktopWidth(), LargeFonts(), nSize

RETURN nSize 

///////////////////////////////////////////////////////////////////////////////////////////
//         
//  :        nSizeFont := IIF(LargeFonts(),9,11)
FUNCTION LargeFonts()  
LOCAL hDC, nPixelX  
hDC := CreateDC( "DISPLAY", "", "" ) 
nPixelX := GetDevCaps( hDC ) 
DeleteDC( hDc ) 
RETURN (nPixelX == 120) 

#pragma BEGINDUMP 
#include <windows.h> 
#include "hbapi.h" 
HB_FUNC( CREATEDC ) 
{ 
   hb_retnl( ( LONG ) CreateDC( hb_parc( 1 ), hb_parc( 2 ), hb_parc( 3 ), 0 ) ); 
} 
HB_FUNC( DELETEDC ) 
{ 
   hb_retl( DeleteDC( ( HDC ) hb_parnl( 1 ) ) ); 
} 
HB_FUNC ( GETDEVCAPS ) 
{ 
 INT      ix; 
 HDC      hdc; 
 hdc = ( HDC ) hb_parnl( 1 ); 
     
 ix  = GetDeviceCaps( hdc, LOGPIXELSX );  
    
 hb_retni( (UINT) ix ); 
} 
#pragma ENDDUMP 

