/*
 * MINIGUI - Harbour Win32 GUI library 
 *
 * Copyright 2017 Verchenko Andrey <verchenkoag@gmail.com>
*/

#include "minigui.ch"
#include "excel.ch"

//////////////////////////////////////////////////////////////////////
FUNCTION MyCreateXls(cPath)
   LOCAL cFileName := cPath + "\" + "test_00001.xls"
   LOCAL cFile, cBuff, nI

   IF MyCreateNewXls(cFileName)
      cBuff := HB_MemoRead(cFileName)      //    
      FOR nI := 20 TO 14 STEP -1
         cFile := "test_000" + HB_NtoS(nI) + ".xls"
         HB_MemoWrit( cPath + "\" + cFile, cBuff )   //   
      NEXT
   ENDIF

   RETURN Nil

//////////////////////////////////////////////////////////////////////
FUNCTION MyCreateNewXls(cFileName)
   LOCAL nI, oExcel, nVerExcel, oWorkBook, oSheet, cMsg, nErr
   LOCAL nLine, nCount, aDim, cFont, nFSize, cType, xValue, nDecVal
   LOCAL cTitle := "    Xls  Csv"

   IF ! IsExcelFound()   //  Excel  
      RETURN .F.
   ENDIF

   IF FILE( cFileName )
      nErr := DELETEFILE(cFileName)
      IF nErr # 0
         cMsg := REPLICATE( "-._.", 16 ) + ";;"
         cMsg += "  : "+cFileName+" !; : "+HB_NtoS(nErr)+";;"
         cMsg += "      !;;"
         cMsg += REPLICATE( "-._.", 16 ) + ";;"
         cMsg := AtRepl( ";", cMsg, CRLF )
         MsgStop( cMsg , "Error!" )
         RETURN .F.
      ENDIF
   ENDIF

   //oExcel := win_oleCreateObject("Excel.Application") 
   oExcel := TOleAuto():New( "Excel.Application" )
   oExcel:Visible := .F. // Not show EXCEL
   oExcel:DisplayAlerts := .F. // Do not bother with queries in Excel

   nVerExcel := VAL( oExcel:Version )   // version Excel
   oWorkBook := oExcel:WorkBooks:Add()  // new Excel page
   //oWorkBook := oExcel:ActiveWorkBook() 

   oSheet := oExcel:ActiveSheet()
   cFont := "Arial" ;  nFSize := 12  // Set font for all cells
   oSheet:Cells:Font:Name := cFont
   oSheet:Cells:Font:Size := nFSize

   nLine  := 3  // from where the table begins
   nCount := 7  // number of columns in the table
   // ------- table header ---------------
   oSheet:Cells( 1, 1 ):Value := cTitle
   oSheet:Cells( 1, 1 ):Font:Size := nFSize
   // Combine the cells of the selected range from 1 to nCount into one cell
   oSheet:Range(oSheet:cells(1,1),oSheet:cells(1,nCount)):MergeCells:=.t. 
   oSheet:Cells( 1, 1 ):HorizontalAlignment := xlCenter 

   DO WHILE .T.

      aDim := { DATE(), "901010"+HB_NtoS(10+nLine), "001", " - ", "11A" , HB_NtoS(nLine), 100-(nLine*1.5) }

      FOR nI := 1 TO LEN(aDim)
         cType   := VALTYPE(aDim[nI])
         xValue  := aDim[nI]  
       
         IF cType == "D"
            oSheet:Cells( nLine, nI ):SET( "NumberFormat", "@" ) 
         ELSEIF cType == "N"
            nDecVal := xValue - INT(xValue)   
            IF nDecVal == 0   //   
               oSheet:Cells( nLine, nI ):SET( 'NumberFormat', '## ### ###0' ) 
            ELSE 
               oSheet:Cells( nLine, nI ):SET( 'NumberFormat', '## ### ###0,00' ) 
            ENDIF
         ELSE
            oSheet:Cells( nLine, nI ):SET( "NumberFormat", '@' ) 
         ENDIF
         oSheet:Cells( nLine, nI ):Value := xValue
         oSheet:Cells( nLine, nI ):Borders():LineStyle := 1
       
      NEXT

      nLine ++
      IF nLine > 103 
         EXIT
      ENDIF

      DO EVENTS  // ALWAYS! To make the form NOT freeze

   ENDDO

   oSheet:Cells( nLine+1, 1 ):Value := "End table"

   cMsg := " : " + ProcName( 0 ) + "(" + hb_ntos( ProcLine( 0 ) ) + ") --> " + ProcFile( 0 ) 
   //? cMsg
   //? 'oWorkBook:SaveAs("'+cFileName+'")' //   _MsgLog.txt

   oWorkBook := oExcel:Get("ActiveWorkBook") 
   oWorkBook:Title := cTitle
   oWorkBook:Subject := cTitle 
   oWorkBook:SaveAs( cFileName, xlWorkbookNormal ) // #include "excel.ch"
   oExcel:Quit()

   RETURN .T.
